Skip to navigation

Retrieve a billing preview run

View as Markdown

Retrieves a preview of future invoice items for multiple customer accounts through a billing preview run. If you have the Invoice Settlement feature enabled, you can also retrieve a preview of future credit memo items. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

A billing preview run asynchronously generates a downloadable CSV file containing a preview of invoice item data and credit memo item data for a batch of customer accounts. Note that if you set storageOption to Database, no CSV file is generate; instead, you can have a record in the billing preview result. You can use data source to query Billing Preview Run Result.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

billingPreviewRunIdstringRequired
Id of the billing preview run.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
assumeRenewalstringOptional
batchesstringOptional

The customer batches included in the billing preview run.

Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 314.0 or a later available version.

chargeTypeToExcludestringOptional
The charge types excluded from the forecast run.
createdByIdstringOptional
The ID of the user who created the billing preview run.
createdDatestringOptional
The date and time when the billing preview run was created.
endDatestringOptional
The date and time when the billing preview run completes.
errorMessagestringOptional
The error message generated by a failed billing preview run.
includingDraftItemsbooleanOptional
Whether draft document items are included in the billing preview run. By default, draft document items are not included.
includingEvergreenSubscriptionbooleanOptional
Indicates if evergreen subscriptions are included in the billing preview run.
organizationLabelslist of objectsOptional

The organization(s) that the object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

resultFileUrlstringOptional

The URL of the zipped CSV result file generated by the billing preview run. This file contains the preview invoice item data and credit memo item data for the specified customers.

If the value of storageOption field is Database, the returned resultFileUrl field is null.

Note: The credit memo item data is only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

runNumberstringOptional
The run number of the billing preview run.
startDatestringOptionalformat: "datetime"
The date and time when the billing preview run starts.
statusstringOptional

The status of the >billing preview run.

Possible values:

  • 0: Pending
  • 1: Processing
  • 2: Completed
  • 3: Error
  • 4: Canceled
storageOptionenumOptional

The saving options. The default value is Csv.

Allowed values:
succeededAccountsintegerOptional

The number of accounts for which preview invoice item data and credit memo item data was successfully generated during the billing preview run.

Note: The credit memo item data is only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

successbooleanOptional

Returns true if the request was processed successfully.

targetDatedateOptional
The target date for the billing preview run.
totalAccountsintegerOptional
The total number of accounts in the billing preview run.
updatedByIdstringOptional
The ID of the user who last updated the billing preview run.
updatedDatestringOptional
The date and time when the billing preview run was last updated.

Errors

4XX
Client Request Error
500
Internal Server Error